import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { Count, CountParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

export async function data(params: CountParam) {
  const res = await request.get<ApiResult<Count[]>>(
    MODULES_API_URL + '/shop/count/data',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 分页查询商城销售统计表
 */
export async function pageCount(params: CountParam) {
  const res = await request.get<ApiResult<PageResult<Count>>>(
    MODULES_API_URL + '/shop/count/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商城销售统计表列表
 */
export async function listCount(params?: CountParam) {
  const res = await request.get<ApiResult<Count[]>>(
    MODULES_API_URL + '/shop/count',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商城销售统计表
 */
export async function addCount(data: Count) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/count',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商城销售统计表
 */
export async function updateCount(data: Count) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/count',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商城销售统计表
 */
export async function removeCount(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/count/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商城销售统计表
 */
export async function removeBatchCount(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/count/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商城销售统计表
 */
export async function getCount(id: number) {
  const res = await request.get<ApiResult<Count>>(
    MODULES_API_URL + '/shop/count/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
